{N.Yu.Zolotykh 1999}
{University of Nizhni Novgorod, Russia}

unit BigGCD;
interface
uses BigArith;

procedure BigIntGCD(var D: BigInt; A, B: BigInt);

implementation

procedure BigIntGCD(var D: BigInt; A, B: BigInt);
var
  U, V, R: BigInt;
begin
  U.Init;
  V.Init;
  R.Init;
  AbsValue(U, A);
  AbsValue(V, B);
  while not V.IsZero do
  begin
    Res(R, U, V);
    U.Assign(V);
    V.Assign(R);
  end;
  D.Assign(U);
  U.Done;
  V.Done;
  R.Done;
end;

end.